/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /home/ellis/source/java/xcard/RCS/AccentActionListener.java,v 1.4 2001/09/28 04:20:11 ellis Exp ellis $
 */

package xcard;

import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

public class AccentActionListener implements ActionListener {
	
    String[] e = {"e", "é", "è", "ê", "ë"};
    String [] a = {"a", "á", "à", "â"};
    String [] c = {"c", "ç"};
    String [] o = {"o", "ô"};
    String [] i = {"i", "î", "ï"};
    String [] u = {"u", "ü", "û", "ù"};
    String[][] lists = {e, a, c, o, i, u};

    private int NEXT = 1;
    private int PREVIOUS = -1;
    private JTextField textfield = null;

    public void setJTextField(JTextField field)
    {
	textfield = field;
    }

    public void actionPerformed(ActionEvent e)
    {
	String action = e.getActionCommand();
	    
	if (action.equals("next")) {
	    nextCharacter();
	} else {
	    previousCharacter();
	}
    }

    private String findNextChar(String c, int direction)
    {
	String return_value = null;

	int index = 0;
	boolean found = false;
	while (! found && index < lists.length) {
	    String[] array = lists[index];
	    for (int i = 0; i < array.length; i++) {
		String x = array[i];
		if (c.equals(x)) {
		    int next_index = 0;

		    if (direction == NEXT) {
			next_index = ++i % array.length;
		    } else {
			--i;
			if (i < 0) {
			    i = array.length - 1;
			}
			next_index = i;
		    }
		    return_value = array[next_index];
		    break;
		}
	    }
	    index++;
	}

	return return_value;
    }

    private String swapCharacters(String text, int index, String newCharacter)
    {
	String return_value = null;

	if (text.length() > 0) {
	    if (index >= 0) {
		return_value = text.substring(0, index);
		if ((index + 1) < text.length()) {
		    String remaining = text.substring(index + 1, text.length());
		    return_value = new String(return_value + newCharacter + 
					      remaining);
		} else {
		    return_value = new String(return_value + newCharacter);
		}
	    }
	}
	return return_value;
    }

    private void nextCharacter()
    {
	String text = textfield.getText();
	if (text.length() > 0) {
	    Caret caret = textfield.getCaret();
	    int pos = caret.getDot();
	    int index = pos;
	    if (index > 0) {
		index--;
	    }
	    char c = text.charAt(index);

 	    String nc = findNextChar(String.valueOf(c), NEXT);
	    if (nc != null) {
		text = swapCharacters(text, index, nc);
		textfield.setText(text);
		caret.setDot(pos);
	    }
	}
    }
	
    private void previousCharacter()
    {
	String text = textfield.getText();
	if (text.length() > 0) {
	    Caret caret = textfield.getCaret();
	    int pos = caret.getDot();
	    int index = pos;
	    if (index > 0) {
		index--;
	    }

	    char c = text.charAt(index);

	    String nc = findNextChar(String.valueOf(c), PREVIOUS);
	    if (nc != null) {
		text = swapCharacters(text, index, nc);
		textfield.setText(text);
		caret.setDot(pos);
	    }
	}
    }
}
