package xcard;

import com.apple.eawt.*;

public class AppleMenu extends ApplicationAdapter {
    private static AppleMenu      theAdapter;
    private static com.apple.eawt.Application  theApplication;

    private XCard mainApp;
 
    private AppleMenu(XCard inApp) {
	mainApp = inApp;
    }
 
    public void handlePreferences(ApplicationEvent ae) {
	if (mainApp != null) {
	    mainApp.preferences();
	    ae.setHandled(true);
	} else {
	    throw new IllegalStateException("handlePreferences: XCard instance detached from listener");
	}
    }

    public void handleAbout(ApplicationEvent ae) {
	if (mainApp != null) {
	    ae.setHandled(true);
	    mainApp.about();
	} else {
	    throw new IllegalStateException("handleAbout: MyApp instance detached from listener");
	}
    }

    public void handleQuit(ApplicationEvent ae) {
	if (mainApp != null) {
	    ae.setHandled(false);
	    mainApp.quit();
	} else {
	    throw new IllegalStateException("handleQuit: MyApp instance detached from listener");
	}
    }

    // The main entry-point for this functionality.  This is the only method
    // that needs to be called at runtime, and it can easily be done using
    // reflection (see XCard.java) 
    public static void registerMacOSXApplication(XCard inApp) {
	if (theApplication == null) {
	    theApplication = new com.apple.eawt.Application();
	}   
  
	if (theAdapter == null) {
	    theAdapter = new AppleMenu(inApp);
	}
	theApplication.addApplicationListener(theAdapter);
    }
 
    // Another static entry point for EAWT functionality.  Enables the 
    // "Preferences..." menu item in the application menu. 
    public static void enablePrefs(boolean enabled) {
	if (theApplication == null) {
	    theApplication = new com.apple.eawt.Application();
	}
	theApplication.setEnabledPreferencesMenu(enabled);
    }
}