/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /h/ellis/source/java/xcard/RCS/BrowserService.java,v 1.2 2001/09/28 04:48:36 ellis Exp $
 */

package xcard;

import java.net.*;
import javax.jnlp.*;

public class BrowserService extends Service {

    public boolean displayURL(URL url) 
    {
	boolean handled = false;

	try {
	    // Lookup the javax.jnlp.BasicService object
           BasicService bs = 
	       (BasicService)ServiceManager.lookup("javax.jnlp.BasicService");
           // Invoke the showDocument method
           handled = bs.showDocument(url);
       } catch(UnavailableServiceException ue) {
           // Service is not supported
       }
	return handled;
    }


}
