/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /h/ellis/source/java/xcard/RCS/EntryListCellRenderer.java,v 1.4 2001/09/28 04:59:35 ellis Exp $
 */

package xcard;

import java.net.URL;
import java.awt.*;
import javax.swing.*;

public class EntryListCellRenderer extends JLabel implements ListCellRenderer {

    private Resource resource = new Resource();

    public EntryListCellRenderer()
    {
	setOpaque(true);
	setIconTextGap(8); // Double the gap
    }

    public Component getListCellRendererComponent(JList list, Object value,
						  int index, 
						  boolean isSelected,
						  boolean cellhasFocus) {
	DefaultListModel model = (DefaultListModel) list.getModel();
	Entry entry = (Entry) model.getElementAt(index);
	setText(entry.getFullWord());
	int state = entry.getState();
	
	String scoreIcon = "face-sad-small.png";

	switch (state) {
	    
	case State.POOR:
	    scoreIcon = "face-sad-small.png";
	    break;

	case State.AVERAGE:
	    scoreIcon = "face-worried-small.png";
	    break;

	case State.GOOD:
	    scoreIcon = "face-smile-small.png";
	    break;

	case State.EXCELLENT:
	    scoreIcon = "face-win-small.png";
	    break;
	}
	URL icon = resource.get("xcard/resources/" + scoreIcon);
	setIcon(new ImageIcon(icon));

	if (isSelected) {
	    setForeground(list.getSelectionForeground());
	    setBackground(list.getSelectionBackground());
	} else {
	    setForeground(list.getForeground());
	    setBackground(list.getBackground());
	}

	return this;
    }
}
