/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /h/ellis/source/java/xcard/RCS/EntryNameComparator.java,v 1.2 2001/09/28 04:42:25 ellis Exp $
 */

package xcard;

import java.util.Comparator;

public class EntryNameComparator implements Comparator {

    public int compare(Object o1, Object o2)
    {
	int return_value;

	if (! (o1 instanceof Entry) || ! (o2 instanceof Entry)) {
	    throw new ClassCastException();
	}
	Entry e1 = (Entry) o1;
	Entry e2 = (Entry) o2;
	
	String n1 = e1.getWord();
	String n2 = e2.getWord();

	return_value = n1.compareTo(n2);
	return return_value;
    }
}
