/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /home/ellis/source/java/xcard/RCS/OpenService.java,v 1.7 2002/11/21 04:40:40 ellis Exp $
 */

package xcard;

import java.io.*;
import java.awt.event.*;
import javax.swing.*;


public class OpenService extends FileService implements ActionListener {

    private void normalOpen()
    {
	try {
	    PreferencesService ps = XCard.getPreferencesService();
	    File dir = ps.getDefaultFileDirectory();

	    chooser.setCurrentDirectory(dir);
	    int state = chooser.showOpenDialog(null);
	    File chosenFile = chooser.getSelectedFile();

	    if (chosenFile != null && 
		state == JFileChooser.APPROVE_OPTION) {
		if (chosenFile.exists()) {
		    File parent = chosenFile.getParentFile();
		    if (parent != null && parent.isDirectory()) {
			ps.setDefaultFileDirectory(parent.getCanonicalPath());
		    }
		    CardEngine engine = XCard.getEngineInstance();
		    engine.load(chosenFile);
		} else {
		    Message.errorMessage("FILE_DOES_NOT_EXIST", 
					 chosenFile.getName());
		}
	    } 
	} catch (Exception e) {
	    Message.errorMessage(e);
	}
    }

    public void open()
    {
	CardEngine engine = XCard.getEngineInstance();
	boolean load_words = false;
	if (engine.isCardListModified()) {
	    Message message = new Message();
	    int saved = message.showUnSavedMessage(engine);
	    if (saved == Message.NO) {
		load_words = true;
	    }
	} else {
	    load_words = true;
	}
	
	if (load_words) {
	    normalOpen();
	    engine.getCardList().sortByScore();
	    fireServiceEvent("OPEN_SERVICE", this);
	}
    }

    public void actionPerformed(ActionEvent e) {
	open();
    }
}
