/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /home/ellis/source/java/xcard/RCS/Parlez.java,v 1.4 2003/12/08 00:06:15 ellis Exp $
 */

package xcard;

import java.io.*;
import java.net.*;

public class Parlez extends XCardBase {
    private String message = null;
    
    protected void setStatus(String msg)
    {
	message = msg;
	fireXCardEvent("LOOKUP_STATUS", message);
    }

    public String getStatus()
    {
	return message;
    }

    public File getWavFile(String text, String langOutputVoice) 
	throws IOException
    {
	File file = null;

	String request = URLEncoder.encode(text, "UTF-8");
	URL url = null;

	if (langOutputVoice.equals("fr")) {
	    //url = new URL("http://www.crisco.unicaen.fr/cgi-bin/KaliClientMain");
	    url = new URL("http://elsap1.unicaen.fr/cgi-bin/KaliClient");
	} else {
	    url = new URL("http://www.festvox.org/cgi-bin/gen_fest.wav");
	}
	
	HttpURLConnection httpConn = (HttpURLConnection) url.openConnection();
	httpConn.setDoOutput(true);
	httpConn.setRequestMethod("POST");

	OutputStream os = httpConn.getOutputStream();
	OutputStreamWriter ow = new OutputStreamWriter(os);

	if (langOutputVoice.equals("fr")) {
	    ow.write("&text=" + request + "&langue=1&mode=0&volume=10&debit=5&hauteur=6&voix=3&prosodie=8");

	} else {
	    //ow.write("&InputText=" + request  + "&OutFormat=wav&SampleRateOut=11025&Count=0&JSflg=0&WhichDemo=ttsdemo");
	    ow.write("&text=" + request + "&voice=us1 (American Female, MBROLA)&format=wav");
	}
	ow.close();
	
	setStatus("Trying to connect");
	httpConn.connect();

	setStatus("Making request");

	setStatus("Reading response");
	InputStream is = httpConn.getInputStream();

	setStatus("Retrieving data");
	file = getFile(is);
	is.close();

	setStatus("Finished");
	    
	return file;
    }

    private File getFile(InputStream is) throws IOException
    {
	FileOutputStream fs = null;
	File file = null;
	try {
	    file = File.createTempFile("XCard", ".wav");
	    fs = new FileOutputStream(file);

	    byte[] b = new byte[1024];
	    int n = 0;
	    while ((n = is.read(b)) >= 0) {
		fs.write(b, 0, n);
	    }
	} finally {
	    if (fs != null) {
		fs.close();
	    }
	}
	return file;
    }

    public static void main(String[] argv)
    {
	try {
	    Parlez parlez = new Parlez();
	    File file = parlez.getWavFile("Hello", "en");
	    System.out.println(file);
	    parlez.getWavFile("Bienvenue", "fr");
	} catch(Exception e) {
	    e.printStackTrace();
	}
    }
}
