/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /Volumes/rage/source/java/xcard/RCS/Resource.java,v 1.8 2002/11/21 04:40:40 ellis Exp ellis $
 */

package xcard;

import java.io.*;
import java.net.URL;
import java.util.*;
import javax.jnlp.ServiceManager;
import javax.jnlp.UnavailableServiceException;

public class Resource {

    static ResourceBundle properties = null;
    static ResourceBundle wordProperties = null;

    public Resource()
    {
	try {
	    if (properties == null) {
		properties =
		    ResourceBundle.getBundle("xcard.resources.xcard");
	    }
	    if (wordProperties == null) {
		wordProperties = ResourceBundle.getBundle("words.word");
	    }

	} catch (MissingResourceException mre) {
            System.err.println(mre.getMessage());
            System.exit(1);
        }
    }

    public URL get(String resource)
    {
	Class c = this.getClass();
	ClassLoader loader = c.getClassLoader();
	URL url = loader.getResource(resource);
	return url;
    }

    public boolean JVMsupportsSound()
    {
	boolean soundSupport = true;
	String version = System.getProperty("java.version");
	if (version.startsWith("1.2")) {
	    soundSupport = false;
	}
	return soundSupport;
    }

    public String getProperty(String key) throws IOException
    {
	return properties.getString(key);
    }

    public String getWordProperty(String key) throws IOException
    {
	return wordProperties.getString(key);
    }

    public boolean isWebStartDeployed()
    {
	boolean enabled = true;
	try {
	    ServiceManager.lookup("javax.jnlp.FileOpenService");
	} catch (UnavailableServiceException e) {
	    enabled = false;
	}
	return enabled;
    }

    public static boolean isApple()
    {
	boolean result = false;

	String vendor = System.getProperty("mrj.version");
	if (vendor != null) {
	    result = true;
	}

	return result;
    }

    public static boolean isWindows()
    {
	boolean result = false;
	
	String os = System.getProperty("os.name");
	if (os.startsWith("Windows")) {
	    result = true;
	}
	
	return result;
    }
}
