/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /h/ellis/source/java/xcard/RCS/Service.java,v 1.3 2001/09/28 04:33:48 ellis Exp $
 */

package xcard;

import java.util.*;

public class Service  {
    List list = new ArrayList();

    public void addServiceEventListener(ServiceEventListener l)
    {
	list.add(l);
    }

    public void removeServiceEventListener(ServiceEventListener l)
    {
	list.remove(l);
    }

    protected void fireServiceEvent(String eventName, Service service)
    {
	ServiceEvent event = new ServiceEvent(this);
	event.setName(eventName);
	event.setService(service);

	Iterator iterator = list.iterator();
	while (iterator.hasNext()) {
	    ServiceEventListener l = (ServiceEventListener) iterator.next();
	    l.actionEvent(event);
	}
    }
}
