/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /h/ellis/source/java/xcard/RCS/SessionEntry.java,v 1.4 2001/09/28 04:25:40 ellis Exp $
 */

package xcard;

import java.util.Date;

public class SessionEntry {

    Date date = null;
    int excellent = 0;
    int good = 0;
    int average = 0;
    int poor = 0;
    int score = 0;

    public SessionEntry()
    {
	this(new Date());
    }

    public SessionEntry(Date date)
    {
	this.date = date;
    }

    public void setDate(Date date)
    {
	this.date = date;
    }

    public Date getDate()
    {
	return date;
    }
    
    public void setScore(int score)
    {
	this.score = score;
    }

    public int getScore()
    {
	return score;
    }

    private void computeScore()
    {
	score = (excellent * 3) + (good * 2) + (average * 1) + (poor * -1);
    }

    public void setSessionScore(CardList cardList)
    {
	excellent = cardList.size(State.EXCELLENT);
	good = cardList.size(State.GOOD);
	average = cardList.size(State.AVERAGE);
	poor = cardList.size(State.POOR);
	computeScore();
    }

    public void setSessionScore(int state, int score)
    {
	switch (state) {

	case State.EXCELLENT:
	    excellent = score;
	    break;

	case State.GOOD:
	    good = score;
	    break;
	    
	case State.AVERAGE:
	    average = score;
	    break;

	case State.POOR:
	    poor = score;
	    break;
	}
	computeScore();
    }

    public int getSessionScore(int state)
    {
	int return_value = -1;

	switch (state) {

	case State.EXCELLENT:
	    return_value = excellent;
	    break;

	case State.GOOD:
	    return_value = good;
	    break;
	    
	case State.AVERAGE:
	    return_value = average;
	    break;

	case State.POOR:
	    return_value = poor;
	    break;
	}
	return return_value;
    }
}
