/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /home/ellis/source/java/xcard/RCS/SplashScreen.java,v 1.4 2001/09/28 04:18:16 ellis Exp $
 */
package xcard;

import java.awt.*;
import java.net.URL;
import java.io.IOException;
import javax.swing.*;
import javax.swing.border.*;


public class SplashScreen extends JWindow 
{
    private Thread thread;
    private boolean finished;
    private JProgressBar progress;
    private JLabel icon = null;

    public SplashScreen()
    {
	JPanel pane = new JPanel(new BorderLayout());
	pane.setFont(new Font("Monospaced", 0, 14));
	Resource resource = new Resource();
	URL splash = resource.get("xcard/resources/XCard.jpg");
	icon = new JLabel();
	icon.setIcon(new ImageIcon(splash));
	pane.add(BorderLayout.NORTH, icon);

	progress = new JProgressBar(0, 100);
	pane.add(BorderLayout.CENTER, progress);

	try {
	    String version = resource.getProperty("version");
	    pane.add(BorderLayout.SOUTH, new JLabel(version + " XCard Release",
						    SwingConstants.CENTER));
	} catch (IOException e) {
	    Message.errorMessage(e);
	}

	pane.setBorder(new EtchedBorder(EtchedBorder.RAISED));
	getContentPane().add(pane);

	Toolkit toolkit = Toolkit.getDefaultToolkit();
	Dimension screen_sz = toolkit.getScreenSize();
	Dimension imageSize = icon.getPreferredSize();
	int imageWidth = imageSize.width;
	int imageHeight = imageSize.height;

	setLocation(screen_sz.width / 2 - (imageWidth / 2),
		    screen_sz.height / 2 - (imageHeight / 2));

	setBackground(Color.lightGray);

	pack();

    }

    public void setProgress(int percent)
    {
	progress.setValue(percent);
    }
}
