/* XCard
 * Author: Shawn Ellis
 * (C) Copyright 2000 
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Header: /home/ellis/source/java/xcard/RCS/XCardBase.java,v 1.4 2001/12/18 05:12:57 ellis Exp $
 */

package xcard;

import java.util.*;
import javax.swing.*;

public class XCardBase {
    List list = new ArrayList();

    public void addXCardEventListener(XCardEventListener l)
    {
	list.add(l);
    }

    public void removeXCardEventListener(XCardEventListener l)
    {
	list.remove(l);
    }

    protected void fireXCardEvent(String eventName, Object o)
    {
	XCardEvent event = new XCardEvent(this);
	event.setName(eventName);

	Iterator iterator = list.iterator();
	while (iterator.hasNext()) {
	    XCardEventListener l = (XCardEventListener) iterator.next();
	    l.actionEvent(event);
	}
    }
}
